/**
  Două cuvinte se numesc "de tip fazan" dacă fiecare are cel puțin 3 litere
și ultimele două litere de la primul cuvînt coincid cu primele două litere
de la ultimul cuvânt.
De exemplu "testare" și "restaurant" sunt două cuvinte de tip fazan.

  Se dă un string cu maxim 1000 de caractere în care avem cuvinte formate
doar din litere mici ale alfabetului englezesc și spații (pot fi mai multe spații
între două cuvinte).
  Se cere să se formeze un șir de cuvinte, separate printr-un singur spațiu,
astfel:
 - se pornește de la primul cuvânt dintre cele date care are cel puțin 3 litere
 - la fiecare pas se parcurge șirul cuvintelor și se ia primul cuvânt care
este de tip fazan cu ultimul cuvânt adăugat la șirul în curs de formare.
  În momentul în care NU mai poate fi ales niciun cuvânt, algoritmul se oprește.

  Odată folosit un cuvânt NU îl mai folosim și a doua oară.

  Completați funcția de mai jos, astfel încât pe baza șirului primit prin
parametrul s să returneze șirul format după regula de mai sus.
Ex:
dacă s are conținutul:
si  ea   ana    este    la pagina   cu tipa   cu narcise pitici   si   nascoceste
serpi ciopliti cu dalta
Răspuns:
ana narcise serpi pitici ciopliti tipa pagina nascoceste

*/
#include <bits/stdc++.h>
using namespace std;

int cuvinte_ok(string cuv1,string cuv2)
{
    if(cuv1.size()>=3 && cuv2.size()>=3 &&
       cuv1.substr(cuv1.size()-2,2)==cuv2.substr(0,2))
            return 1;
    return 0;
}

string fazan(string s)
{
    ///TOTO: implement this function
///Etapa1: pe baza stringului dat formez un șir (array) în care extrag toate
///cuvintele din acesta - putem să le eliminăm încă din timpul formării pe
///cele care au sub 3 litere.
///Notăm acest șir cu "cuv" și vom avea cuv[1]="ana" cuv[2]="este"
///cuv[3]="pagina", ...
    ///(am făcut deja splituire de string în mai multe cuvinte - pentru asta
        ///adăugăm un spațiu la final și facem o repetitivă care la fiecare
        ///pas caută primul spațiu, extrage cuvântul și apoi îl șterge
    string cuv[500];
    int i,nc=0,pos;///nc=numărul de cuvinte din vectorul cuv
    s+=" ";///lipim un spațiu la s ca să putem lucra în același mod extragerea
    ///tuturor cuvintelor, inclusiv a ultimului, după care NU era spațiu
    pos=s.find(" ");
    while(pos!=-1)
    {///deci a găsit spațiu, căci dacă n-ar fi găsit ar fi întors -1
        if(pos>=3)///preluăm DOAR cuvintele cu minim 3 litere
            cuv[++nc]=s.substr(0,pos);
///cuv[++nc] înseamnă că întâi crește nc și se face atribuirea cu nc-ul crescut
        s.erase(0,pos+1);
        pos=s.find(" ");
    }
/**ca să facem o testare intermediară aici putem afișa șirul de cuvinte:
    for(i=1;i<=nc;i++)cout<<cuv[i]<<"\n";  */
    string rez="",last;///acesta va fi rezultatul final, cel pe care îl returnăm din
///funcție. Îl obținem prin concatenări repetate ale cuvintelor care se potrivesc
    ///în "last" reține ultimul cuvânt concatenat la rez
    rez=cuv[1];last=cuv[1];cuv[1]="";///ștergem cuv[1] ca să Nu cumva să se ia
    ///din greșeală pe viitor
///facem o repetitivă infinită din care ieșim cu break când nu mai avem cuvinte
    while(1)
    {///căutăm primul cuvânt din șir care face pereche fazan cu "last":
        for(i=1;i<=nc;i++)
            if(cuvinte_ok(last,cuv[i]))
                break;
        ///dacă for-ul de mai sus iese cu break i = indicele cuvântului căutat
        ///dacă nu iese cu break, la ieșire i==nc+1
        if(i>nc)break;///acest break oprește while-ul
        rez=rez+" "+cuv[i];
        last=cuv[i];
        cuv[i]="";
    }
    return rez;
}

int main()
{
    string s;
    ///getline(cin,s);
    s="si  ea   ana    este    la pagina   cu tipa   cu narcise pitici   si   nascoceste serpi ciopliti cu dalta";
    cout<<fazan(s);
    return 0;
}
